//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 08: OpenAcc
//
//  Description: Simple example Add numbers in array A
//      Author: Evangelos Dermatas
//      v0.1

/*
*********************************************************************
gcc -v: gcc version 9.2.1 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 19.10
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:   gcc accAddEx1.c -o accAddEx1 -O3 -fopenacc -foffload=nvptx-none  -fopt-info
Executing:    ./accAddEx1

Output in my Laptop

Total sum 5081496813568.000000

real	0m0.083s
user	0m0.065s
sys	0m0.018s

*/

#include <stdio.h>
#include <omp.h>
//#include <openacc.h>

#define N 10000000
float A[N] ;

// ***************************************************************    αρχίζουμε 17:30
int main(int argc, char *argv[])
{

//#pragma acc parallel loop copyout( A[0:N] )
#pragma omp enter data map(alloc:A[0:N]) 
#pragma omp target teams distribute parallel for
//#pragma omp parallel for
   for(int i=0; i < N; i++)
     A[i] = i/10.0;

#pragma omp data update from(A[0:N])
   float sum=0;
#pragma omp target teams distribute parallel for reduction(+:sum)
//#pragma omp parallel for reduction(+:sum)
   for(int i=0; i < N; i++)
     sum+=A[i] ;

   printf( "Total sum %f\n", sum);

   return 0; // normal exit
}
