//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 09: OpenMp for Graphics accelerators
//
//  Description: Put Numbers in array A in the GPU
//      Author: Evangelos Dermatas
//      v0.1

/*
*********************************************************************
gcc -v: gcc version 9.2.1 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 19.10
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************

Compiling:   gcc accFillEx2.c -o accFillEx2 -O3 -fopenmp -foffload=nvptx-none  -fopt-info -foffload=-lm
Executing:    ./accFillEx2

Output in my Laptop
*/

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>


#define N 10000000
float A[N] ;
float sum ;

// ***************************************************************
int main(int argc, char *argv[])
{

#pragma omp target map(tofrom:A[0:N])
   for(int i=0; i < N; i++)
     A[i] = i/10.0;

#pragma omp parallel for reduction(+:sum)
   for(int i=0; i < N; i++)
      sum+=A[i] ;

   printf( "Sum=%f\n", sum);

   return 0; // normal exit
}
